global int WINDOW_SIZE;

public class Boat extends GGen {
	vec3 vertices[0];
	vec3 prev[WINDOW_SIZE];

	(WINDOW_SIZE / 7.5 * (posX() + 3.75)) $ int => int i;

	1 => float m;
	float f;
	float a;
	float v;
	-3.25 => float x;
	0.75 => float mu;

	GMesh b --> GCube p --> GMesh s --> this;

	// Hull
	SphereGeometry geo;
	PhongMaterial mat;

	@(0.2, 0.2, 0.2) => s.sca;

	(1, 100, 100, -Math.PI / 6, -2 * Math.PI / 3, -Math.PI / 2, -Math.PI / 4) => geo.set;
	@(186. / 255., 140. / 255., 99. / 255.) => mat.color;

	geo => s.geo;
	mat => s.mat;

	// Pole
	@(0.1, 2, 0.1) => p.sca;
	@(186. / 255., 140. / 255., 99. / 255.) => p.mat().color;

	// Flag
	CustomGeometry g1;
	PhongMaterial m1;

	[@(0, 0, 0), @(10, 0, 0), @(0, 0.5, 0)] => g1.positions;
	@(1, 1, 1) => m1.color;

	g1 => b.geo;
	m1 => b.mat;

	now => time start;
  fun void update(float dt) {
		if (vertices.size() == 0) return;

		if (i >= WINDOW_SIZE || i < 0) {
      WINDOW_SIZE / 2 => i;
      0 => posX;
      0 => x;
    }

		float left;
		float right;

		int lc;
		int rc;

		for (((0, i - 10) => Math.max) $ int => int j; j < i; j++, lc++) vertices[j].y +=> left;
		for (i + 1 => int j; j < ((WINDOW_SIZE, i + 11) => Math.min) $ int; j++, rc++) vertices[j].y +=> right;

		if (left < right && Math.PI / 6 >= rotZ().x) rotZ().x + 1.5 * dt => rotZ;
		else if (left > right && -Math.PI / 6 <= rotZ().x) rotZ().x - 1.5 * dt => rotZ;

		if (lc < 10) 100 => f;
		else if (rc < 10) -100 => f;
		else 100 * (left / lc - right / rc) => f;

		if (f > 500) 500 => f;
		else if (f < -500) -500 => f;

		f / m => a;

		a * dt +=> v;

		if (v > 0) mu * dt -=> v;
		else if (v < 0) mu * dt +=> v;

		v * dt +=> x;

		x => posX;

		vertices[i].y / 2 + 0.1 => posY;

		(WINDOW_SIZE / 7.5 * (posX() + 3.75)) $ int => i;
  }
}
