global int WINDOW_SIZE;

public class Cloud extends GGen {
	GMesh c[Math.random2(10, 15)];
	CustomGeometry g;

	vec3 vertices[WINDOW_SIZE * 6];
	float normals[vertices.size() * 3];

	for (auto cloud : c) {
		PhongMaterial m;
		@(1, 1, 1) => m.color;

		cloud --> this;
		g => cloud.geo;
		m => cloud.mat;
		Math.random2f(1, 5) => cloud.scaX;
		Math.random2f(1, 2) => cloud.scaY;
		Math.random2f(0.1, 1) => cloud.mat().alpha;
		@(Math.random2f(-20, 20), Math.random2f(5, 10), Math.random2f(-30, 30)) => cloud.pos;
	}

	float samples[0];

	fun void update(float dt) {
		if (samples.size() == 0) return;

		for (auto cloud : c) {
			cloud.posZ() - Math.random2f(0.5, 1) * dt => cloud.posZ;
			cloud.mat().alpha() - Math.random2f(0.005, 0.05) * dt => cloud.mat().alpha;

			if (cloud.mat().alpha() <= 0) {
				@(Math.random2f(-20, 20), Math.random2f(5, 10), 25) => cloud.pos;
				Math.random2f(0.5, 3) => cloud.scaX;
				1 => cloud.mat().alpha;
			}
		}

    int i;
    for (auto s : samples) {
      -3. / 2. + 3. / WINDOW_SIZE * i => float x;
      3 * s => float y;
      float z;

      @(x, y, z) => vertices[6 * i];
      @(x - 0.01, y - 0.1, z) => vertices[6 * i + 1];
      @(x + 0.01, y - 0.1, z) => vertices[6 * i + 2];

      @(x, y - 1, z) => vertices[6 * i + 3];
      @(x - 0.01, y - 0.1, z) => vertices[6 * i + 4];
      @(x + 0.01, y - 0.1, z) => vertices[6 * i + 5];

      0 => normals[18 * i];
      0 => normals[18 * i + 1];
			-1 => normals[18 * i + 2];
			0 => normals[18 * i + 3];
      0 => normals[18 * i + 4];
      -1 => normals[18 * i + 5];
      0 => normals[18 * i + 6];
			0 => normals[18 * i + 7];
			-1 => normals[18 * i + 8];
			0 => normals[18 * i + 9];
			0 => normals[18 * i + 10];
			-1 => normals[18 * i + 11];
			0 => normals[18 * i + 12];
			0 => normals[18 * i + 13];
			-1 => normals[18 * i + 14];
			0 => normals[18 * i + 15];
			0 => normals[18 * i + 16];
			-1 => normals[18 * i + 17];

      i++;
    }

    vertices => g.positions;
    normals => g.normals;
	}
}
