public class Narrative {
	Event b;
	Event l;
	Event t;
	Event end;

	Gain master => dac;

	0.1 => master.gain;

  fun void sweep() {
  	SinOsc osc => master;
    0.005 => osc.gain;
  	69 + 3 * 12 => Std.mtof => osc.freq;
  	while (osc.freq() > 220) {
  		osc.freq() - 1 => osc.freq;
  		1::ms => now;
  	}
  }

	fun void upper() {
		Rhodey r => NRev rev => LPF f => Gain g => master;

    2 => g.gain;
    0.4 => rev.mix;
    69 => Std.mtof => f.freq;

    2 => r.lfoSpeed;
    0.0 => r.lfoDepth;
    (0, 0.1) => r.opAM;
    (2, 0.1) => r.opAM;
    (0, 0.001, 1.50, 0.0, 0.04) => r.opADSR;
    (2, 0.001, 1.50, 0.0, 0.04) => r.opADSR;

		0.5::second => now;

    69 - 1 => Std.mtof => r.freq;
    0.8 => r.noteOn;
    1.5::second => now;

    69 + 4 => Std.mtof => r.freq;
    0.8 => r.noteOn;
    4::second => now;
    0 => r.noteOff;

    2::second => now;

		0.5::second => now;

    69 - 1 => Std.mtof => r.freq;
    0.8 => r.noteOn;
    1.5::second => now;

    69 + 4 => Std.mtof => r.freq;
    0.8 => r.noteOn;
    4::second => now;
    0 => r.noteOff;

    2::second => now;

		0.5::second => now;

    69 - 1 => Std.mtof => r.freq;
    0.8 => r.noteOn;
    1.5::second => now;

    69 + 4 => Std.mtof => r.freq;
    0.8 => r.noteOn;
    2::second => now;

    69 + 7 => Std.mtof => r.freq;
    0.8 => r.noteOn;
    2::second => now;

    69 - 1 => Std.mtof => r.freq;
    0.8 => r.noteOn;
    4::second => now;

    69 - 3 => Std.mtof => r.freq;
    0.8 => r.noteOn;
    4::second => now;
	}

	fun void lower() {
    [[69 + 12 + 7, 69 + 12 + 4, 69 + 11, 69 + 9],
     [69 + 12, 69 + 11, 69 + 4, 69 + 7]] @=> int p[][];

    Clarinet cs[p.size()];
    NRev r => Gain g => master;

    0.15 => r.mix;
    1.5 => g.gain;

    for (int i; i < cs.size(); i++) {
      cs[i] => r;
      0 => cs[i].pressure;
      0.45 => cs[i].reed;
      1. / cs.size() / 20 => cs[i].gain;
    }

    for (int _; _ < 10; _++) {
      for (int i; i < cs.size(); i++) {
        p[i][0] => Std.mtof => cs[i].freq;
        1 => cs[i].startBlowing;
      }
      1::second => now;
      for (int i; i < cs.size(); i++) p[i][1] => Std.mtof => cs[i].freq;
      (1. + 1. / 3.)::second => now;
      for (int i; i < cs.size(); i++) 0.5 => cs[i].stopBlowing;
      (1. / 3.)::second => now;
      for (int i; i < cs.size(); i++) {
        p[i][2] => Std.mtof => cs[i].freq;
        1 => cs[i].startBlowing;
      }
	    if (_ == 9) l.broadcast();
      (2. / 3.)::second => now;
      for (int i; i < cs.size(); i++) p[i][3] => Std.mtof => cs[i].freq;
      (2. / 3. - 0.01)::second => now;
      for (int i; i < cs.size(); i++) 0.5 => cs[i].stopBlowing;
      10::ms => now;
    }
    2::second => now;
  }

  fun void ocean() {
    CNoise n => ADSR e => NRev r => master;
    0.15 => r.mix;
		(1000::ms, 0::ms, 1, 1::second) => e.set;

    "pink" => n.mode;
    0 => n.gain;

		e.keyOn();
    now => time start;
    while (true) {
      (Math.sin((now - start) / second * 1.5) + 2) / 4 => n.gain;
      10::ms => now;
    }
  }

  fun void barque() {
    SndBuf barque => ADSR e => master;
    0.75 => barque.gain;
		(1000::ms, 0::ms, 1, 1::second) => e.set;
		me.dir() + "/assets/barque-1.wav" => barque.read;
		e.keyOn();
		(barque.samples() - 44100 * 2)::samp => now;
		e.keyOff();
		b.broadcast();
		2::second => now;
  }

  fun void barque2() {
    SndBuf barque => ADSR e => master;
    0.75 => barque.gain;
    (1000::ms, 0::ms, 1, 1::second) => e.set;
    me.dir() + "/assets/barque-2.wav" => barque.read;
    e.keyOn();
    (barque.samples() - 44100 * 2)::samp => now;
    e.keyOff();
    b.broadcast();
    2::second => now;
  }

  fun void harp() {
    StifKarp m => NRev r => dac;
    0.05 => r.gain;
    0.4 => r.mix;

    1 => m.pickupPosition;
    0.8 => m.sustain;
    1 => m.stretch;

    [69 - 12 + 2, 69 - 12 + 4, 69 - 12 + 7, 69 - 2, 69 + 2, 69 + 4, 69 + 7, 69 + 12 - 2] @=> int notes[];

    for (auto note : notes) {
        note => Std.mtof => m.freq;
        0.25 => m.pluck;
        75::ms => now;
    }
    3::second => now;
    notes.reverse();
    for (auto note : notes) {
        note => Std.mtof => m.freq;
        0.25 => m.pluck;
        75::ms => now;
    }
    3::second => now;
  }

  fun void harp2(float offset) {
    StifKarp m => NRev r => dac;
    0.05 => r.gain;
    0.4 => r.mix;

    1 => m.pickupPosition;
    0.8 => m.sustain;
    1 => m.stretch;

    [69 + 24 - 2, 69 + 12 + 6, 69 + 12 + 3, 69 + 12, 69 + 12 - 2, 69 + 6, 69 + 3, 69, 69 - 2, 69, 69 + 3, 69 + 6, 69 + 12 - 2, 69 + 6, 69 + 3, 69, 69 - 2, 69 - 12 + 6, 69 - 12 + 3, 69 - 12, 69 - 12 - 2, 69 - 24 + 6, 69 - 24 + 3, 69 - 24, 69 - 24 - 2, 69 - 24, 69 - 24 + 3, 69 - 24 + 6, 69 - 12 - 2, 69 - 12 - 2, 69 - 24 + 6, 69 - 24 + 3, 69 - 24, 69 - 24 - 2, 69 - 24, 69 - 24 + 3, 69 - 24 + 6, 69 - 24 + 3, 69 - 24, 69 - 24 - 2, 69 - 24 - 5, 69 - 36] @=> int notes[];

    for (auto note : notes) {
        note + offset => Std.mtof => m.freq;
        0.25 => m.pluck;
        75::ms => now;
    }
    3::second => now;
  }

  fun void tremolo(float offset) {
    [[69 + 12 + 6, 69 + 12 + 8],
     [69 + 12 + 2, 69 + 12 + 2]] @=> int p[][];

    Clarinet cs[p.size()];
    ADSR e => NRev r => Gain g => dac;

		(2000::ms, 0::ms, 1, 1::second) => e.set;
    0.2 => r.mix;
    0.75 => g.gain;

    for (int i; i < cs.size(); i++) {
      cs[i] => e;
      1 => cs[i].pressure;
      0.45 => cs[i].reed;
      0.01 => cs[i].vibratoGain;
      1. / cs.size() / 20 => cs[i].gain;
    }

    e.keyOn();

    for (int _; _ < 16; _++) {
      for (int i; i < cs.size(); i++) {
        p[i][0] + offset => Std.mtof => cs[i].freq;
        1 => cs[i].startBlowing;
      }
      100::ms => now;
      for (int i; i < cs.size(); i++) p[i][1] => Std.mtof => cs[i].freq;
      100::ms => now;
    }

    0 => cs[1].stopBlowing;

    69 + 12 + 6 + offset => Std.mtof => cs[0].freq;
    66::ms => now;
    69 + 12 + 8 + offset => Std.mtof => cs[0].freq;
    66::ms => now;
    69 + 12 + 9 + offset => Std.mtof => cs[0].freq;
    66::ms => now;
    69 + 12 + 10 + offset => Std.mtof => cs[0].freq;

    t.broadcast();
    500::ms => now;
    0 => cs[0].stopBlowing;
    e.keyOff();
    2::second => now;
  }

  fun void play() {
	  spork ~ barque();
    2.5::second => now;
    spork ~ sweep();
	  b => now;
    spork ~ sweep();
    spork ~ ocean();
    spork ~ lower();
    8::second => now;
    spork ~ upper();
		l => now;
		spork ~ tremolo(0);
		t => now;
		spork ~ harp2(0);
		3::second => now;
		spork ~ tremolo(-12);
    t => now;
    spork ~ harp2(-12);
    3::second => now;
    spork ~ tremolo(-24);
    t => now;
    spork ~ harp2(-24);
    8::second => now;
		spork ~ harp();
    3::second => now;
    spork ~ lower();
    8::second => now;
    spork ~ upper();
    12::second => now;
    barque2();
  }
}
