global int WINDOW_SIZE;
global int HISTORY;

public class Wave extends GGen {
	CustomGeometry g;

	vec3 vertices[0];
	vec3 triangles[WINDOW_SIZE * 3];
	float normals[triangles.size() * 3];

	GMesh w[Math.random2(20, 40)];

	for (auto wave : w) {
		PhongMaterial m;

		@(0.8, 0.8, 0.8) => m.color;

  	wave --> this;
    g => wave.geo;
    m => wave.mat;
  	@(Math.random2f(7.5, 15) * Math.sgn(Math.random2f(-1, 1)), 0, Math.random2f(-30, 30)) => wave.pos;
  	@(Math.random2f(0.05, 1.5) * Math.sgn(Math.random2f(-1, 1)), 1, 1) => wave.sca;
  }

  for (2 => int i; i < normals.size(); 3 +=> i) -1 => normals[i];

	normals => g.normals;

	fun void update(float dt) {
		if (vertices.size() == 0) return;

		for (auto wave : w) {
			wave.posZ() - Math.random2f(0.1, 0.5) * dt => wave.posZ;
			wave.mat().alpha() - Math.random2f(0.05, 0.2) * dt => wave.mat().alpha;

			if (wave.mat().alpha() <= 0) {
        @(Math.random2f(7.5, 15) * Math.sgn(Math.random2f(-1, 1)), 0, Math.random2f(-30, 30)) => wave.pos;
		    @(Math.random2f(0.05, 1.5) * Math.sgn(Math.random2f(-1, 1)), 1, 1) => wave.sca;
        1 => wave.mat().alpha;
      }
		}

		for (int i; i < WINDOW_SIZE; i++) {
			vertices[i] => triangles[3 * i];
			@(vertices[i].x + 0.01, 0, vertices[i].z + 0.1) => triangles[3 * i + 1];
			@(vertices[i].x - 0.01, 0, vertices[i].z + 0.1) => triangles[3 * i + 2];
		}

		triangles => g.positions;
	}
}
