global int WINDOW_SIZE;
global int HISTORY;
global float WIDTH;

public class Waves extends GGen {
	vec3 vertices[0];
	vec3 triangles[WINDOW_SIZE * 3];
	float normals[triangles.size() * 3];

	Waterfall s --> this;

	for (2 => int i; i < normals.size(); 3 +=> i) -1 => normals[i];

	fun void update(float dt) {
		if (vertices.size() == 0) return;

		for (int i; i < WINDOW_SIZE; i++) {
      @(vertices[i].x, vertices[i].y, 25) => triangles[3 * i];
      @(vertices[i].x + 0.01, 0, 25) => triangles[3 * i + 1];
      @(vertices[i].x, 0, 25) => triangles[3 * i + 2];
    }

    (triangles, normals) => s.latest;
	}
}

class Waterfall extends GGen {
  int playhead;

	CustomGeometry g;
  GMesh wfl[HISTORY];
	@(1, 1, 1) => vec3 color;

  for (auto w : wfl)  {
		PhongMaterial m;

		@(0.8, 0.8, 0.8) => m.color;

    w --> this;
    g => w.geo;
    m => w.mat;
    color => w.mat().color;
  }

  fun void latest(vec3 positions[], float normals[]) {
    positions => wfl[playhead].geo().positions;
    normals => wfl[playhead].geo().normals;
    playhead++;
    HISTORY %=> playhead;
  }

  // update
  fun void update(float dt) {
    playhead => int pos;

    for (int i; i < wfl.size(); i++) {
      pos--;
      if (pos < 0) HISTORY - 1 => pos;

      -2 * i => wfl[pos].posZ;

      1 - pos / HISTORY => wfl[pos].mat().alpha;
    }
  }
}
